<script lang="ts">
  import Modal from '$lib/components/ui-elements/Modal.svelte';
  import Alert from '$lib/components/ui-elements/Alert.svelte';
  import { createEventDispatcher } from 'svelte';
  import type { InvitedUser } from '$lib/graphql/types';
  import type { UserInviteSuccessCallback, PendingUser } from '$lib/interfaces/user-invite';
  import { InviteUserStore } from '$houdini';

  export let open = false;
  export let title = 'Invite User';
  const dispatch = createEventDispatcher();
  let success: UserInviteSuccessCallback | undefined;
  let error = '';
  let pendingUser: PendingUser = {
    firstName: '',
    lastName: '',
    email: '',
    phoneNumber: ''
  };
  $: valid = pendingUser.firstName && pendingUser.lastName && pendingUser.email && pendingUser.phoneNumber;
  $: if (!open) {
    console.log('resetting invite user modal');
    // automatically reset values when form closes
    success = undefined;
    error = '';
    pendingUser = {
      firstName: '',
      lastName: '',
      email: '',
      phoneNumber: ''
    };
  }

  export function show(user?: Partial<PendingUser>, onSuccess?: UserInviteSuccessCallback) {
    console.debug('showing invite user modal', user, success);
    open = true;
    success = onSuccess;
    pendingUser = {
      firstName: '',
      lastName: '',
      email: '',
      phoneNumber: '',
      ...(user || {})
    };
  }

  async function handleSubmit() {
    console.debug('Inviting user', pendingUser);
    const inviteUser = new InviteUserStore();
    const result = await inviteUser.mutate(pendingUser);
    console.log(result);
    if (result.errors) {
      error = result.errors.map((e) => e.message).join('\n');
      throw new Error(error);
    }
    if (result.data?.c2games_user_invite?.error) {
      error = result.data.c2games_user_invite.error;
      throw new Error(error);
    }
    if (!result.data?.c2games_user_invite?.user) {
      error = 'Failed to invite user: no user was provided in the response.';
      throw new Error(error);
    }

    console.debug('user invited successfully; cb=', success);
    // trigger success callback if it exists, and dispatch a userInvited event
    success?.(result.data.c2games_user_invite as InvitedUser); // this shouldn't need a cast, but I'm over it
    dispatch('userInvited', { user: result.data.c2games_user_invite });
    open = false; // close up shop, we're done here
  }
</script>

<Modal bind:open>
  <div slot="title">
    {#if $$slots.title}
      <slot name="title" />
    {:else}
      <h1 class="font-bold text-2xl text-secondary p-4 border-b border-cyber-blue-900">{title}</h1>
    {/if}
  </div>
  <form class="flex flex-col gap-5 text-lg lg:text-xl font-semibold p-5 w-full" on:submit|preventDefault={handleSubmit}>
    <section>
      <label>First Name</label>
      <input
        class="border rounded block w-full text-md font-normal p-1"
        type="text"
        bind:value={pendingUser.firstName} />

      <label>Last Name</label>
      <input
        class="border rounded block w-full text-md font-normal p-1"
        type="text"
        bind:value={pendingUser.lastName} />

      <label>Email</label>
      <input type="email" class="border rounded block w-full text-md font-normal p-1" bind:value={pendingUser.email} />

      <label>Phone Number</label>
      <input
        class="border rounded block w-full text-md font-normal p-1"
        type="text"
        bind:value={pendingUser.phoneNumber} />
    </section>
  </form>
  <div slot="footer" class="flex flex-col">
    {#if error}
      <Alert color="red" class="p-4">
        <div slot="title">Failed to Invite User: {pendingUser.email}</div>
        <p class="whitespace-pre-wrap">{error}</p>
        Please contact
        <a href="mailto:support@c2games.org">support@c2games.org</a>
        if this issue persists.
      </Alert>
    {/if}
    <div class="flex flex-row">
      <button class="bg-red-400 text-center text-white w-1/2 py-4" on:click={() => (open = false)}> Cancel </button>
      <button
        on:click={() => {
          if (valid) handleSubmit();
        }}
        class="{valid ? 'cursor-pointer bg-cyber-blue-900' : 'bg-cyber-gray-600 disabled'} text-white w-1/2 py-1 px-10">
        Invite User
      </button>
    </div>
  </div>
</Modal>
